
# reads a set of trajectories from a file
def readTrajectoryDataset(fileName):
	s = open(fileName, 'r').read();
	comp=s.split("\n")
	trajectory=[];
	trajectorySet=[];
	for i in range(0,len(comp)):
		comp[i]=comp[i].split(" ");
		if(len(comp[i])==2):
			# to double??
			point={
				"x":float(comp[i][0]),
				"y":float(comp[i][1])
			}
			trajectory.append(point);
		else:
			trajectorySet.append(trajectory);
			trajectory=[];
	
	return trajectorySet;
	
def HC_SIM(t1,t2,MIN_EPS):
	csim=C_SIM(t1,t2,MIN_EPS*1);
	csim2=C_SIM(t1,t2,MIN_EPS*2);
	csim3=C_SIM(t1,t2,MIN_EPS*4);
	csim4=C_SIM(t1,t2,MIN_EPS*8);
	csim5=C_SIM(t1,t2,MIN_EPS*16);
	csim6=C_SIM(t1,t2,MIN_EPS*32);
	
	csim+=csim2;
	csim+=csim3;
	csim+=csim4;
	csim+=csim5;
	csim+=csim6;
	
	csim/=6;
	
	return csim;
			
def C_SIM(t1, t2, EPS):
	cells1=getCells(t1,EPS);
	cells2=getCells(t2,EPS);
	
	c1=cells1["cells"];
	dil1=cells1["dil"];
	c2=cells2["cells"];
	dil2=cells2["dil"];
	
	cab=0;
	cabd=0;
	cadb=0;
	ca=0;
	cb=0;
	
	for key,value in c1.items():
		ca+=1;
		if(c2.get(key,-1)==1):
			cab+=1;
		elif(dil2.get(key,-1)==1):
			cabd+=1;
			
	for key,value in c2.items():
		cb+=1;
		if(dil1.get(key,-1)==1 and c1.get(key,-1)!=1):
			cadb+=1;
		
	sim=(cab+cabd+cadb)/(ca+cb-cab);
		
	return sim;
	
def getCells(traj,SIZE):
	c1={};
	for j in range(1,len(traj)):
		px=round(traj[j-1]["x"]/SIZE);
		py=round(traj[j-1]["y"]/SIZE);
		x=round(traj[j]["x"]/SIZE);
		y=round(traj[j]["y"]/SIZE);

		c1[str(px)+"_"+str(py)]=1;
		c1[str(x)+"_"+str(y)]=1;
		
		minX=min(px,x);
		maxX=max(px,x);
		minY=min(py,y);
		maxY=max(py,y);
		deltaX=maxX-minX;
		deltaY=maxY-minY;
		
		#interpolation
		if(deltaX>deltaY):
			for i in range(minX+1,maxX):
				_y=round(py+(y-py)*(i-px)/(x-px));
				_x=i;
				c1[str(_x)+"_"+str(_y)]=1;
		else:
			for i in range(minY+1,maxY):
				_x=round(px+(x-px)*(i-py)/(y-py));
				_y=i;
				c1[str(_x)+"_"+str(_y)]=1;

	#dilation
	dil1={};
	for key,value in c1.items():
		comp=key.split("_");
		x=int(comp[0]);
		y=int(comp[1]);
		
		nx=str(x-1);
		ny=str(y-1);
		dil1[nx+"_"+ny]=1;
		
		nx=str(x-1);
		ny=str(y);
		dil1[nx+"_"+ny]=1;
		
		nx=str(x-1);
		ny=str(y+1);
		dil1[nx+"_"+ny]=1;
		
		
		nx=str(x);
		ny=str(y-1);
		dil1[nx+"_"+ny]=1;
		
		nx=str(x);
		ny=str(y+1);
		dil1[nx+"_"+ny]=1;
		
		
		nx=str(x+1);
		ny=str(y-1);
		dil1[nx+"_"+ny]=1;
		
		nx=str(x+1);
		ny=str(y);
		dil1[nx+"_"+ny]=1;
		
		nx=str(x+1);
		ny=str(y+1);
		dil1[nx+"_"+ny]=1;
		
	return {"cells":c1, "dil":dil1};

	
import os;
import math;
fileName="input.txt";
MIN_EPS=0.005;

if(os.path.isfile(fileName)):
	dataset=readTrajectoryDataset(fileName);
	sim = HC_SIM(dataset[0],dataset[1],MIN_EPS);
	print(str(sim));